> For a complete page index, fetch https://docs.transak.com/llms.txt

# Create Order

POST https://api-gateway-stg.transak.com/api/v2/orders
Content-Type: application/json

The **Create Order** is an **authenticated API** that is a crucial step in **Transak's transaction flow**, allowing users to place a **crypto buy or sell order** based on their **reserved wallet address** and quote ID. This API ensures that the **order is securely created** and **ready for payment processing**.

**Open Banking**

- paymentInstrumentId should be passed as `pm_open_banking`

Reference: https://docs.transak.com/api/whitelabel/payments/open-banking/create-order

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: whitelabel-api
  version: 1.0.0
paths:
  /api/v2/orders:
    post:
      operationId: create-order
      summary: Create Order
      description: >-
        The **Create Order** is an **authenticated API** that is a crucial step
        in **Transak's transaction flow**, allowing users to place a **crypto
        buy or sell order** based on their **reserved wallet address** and quote
        ID. This API ensures that the **order is securely created** and **ready
        for payment processing**.


        **Open Banking**


        - paymentInstrumentId should be passed as `pm_open_banking`
      tags:
        - subpackage_openBanking
      parameters:
        - name: x-user-ip
          in: header
          description: >-
            End user's originating IP. More details
            [here](/guides/mandatory-security-changes#user-ip-header-in-apis)
          required: true
          schema:
            type: string
        - name: x-api-key
          in: header
          description: Partner API Key present in Transak Dashboard.
          required: true
          schema:
            type: string
        - name: authorization
          in: header
          description: >-
            Authorization token is the accessToken received from the API -`
            api/v2/auth/verify`


            Note: This is not applicable for [Auth Reliance
            Flows](/features/auth-reliance)
          required: false
          schema:
            type: string
        - name: x-user-identifier
          in: header
          description: >-
            Your authenticated user Email Id address.


            Note: This is applicable only for [Auth Reliance
            Flows](/features/auth-reliance)
          required: false
          schema:
            type: string
        - name: x-access-token
          in: header
          description: >
            Your Partner Access Token. Please refer
            [here](/guides/how-to-create-partner-access-token) for a tutorial on
            generating your access token.


            Note: This is applicable only for [Auth Reliance
            Flows](/features/auth-reliance)
          required: false
          schema:
            type: string
      responses:
        '200':
          description: Create Order - Bank Transfer
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openBanking:create-order_Response_200'
        '400':
          description: 400 - Missing Field
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/openBanking:Create-orderRequestBadRequestError
        '401':
          description: 401 - Authorization Required
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/openBanking:Create-orderRequestUnauthorizedError
        '404':
          description: 404 - User Not Found
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/openBanking:Create-orderRequestNotFoundError
        '500':
          description: 500 - Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/openBanking:Create-orderRequestInternalServerError
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                quoteId:
                  type: string
                  description: Quote ID generated from `api/v2/lookup/quotes`
                paymentInstrumentId:
                  $ref: >-
                    #/components/schemas/openBanking:ApiV2OrdersPostRequestBodyContentApplicationJsonSchemaPaymentInstrumentId
                  description: Use `pm_open_banking` for Open Banking.
                walletAddress:
                  type: string
                  description: Destination crypto wallet address.
              required:
                - quoteId
                - paymentInstrumentId
                - walletAddress
servers:
  - url: https://api-gateway-stg.transak.com
    description: Staging
components:
  schemas:
    openBanking:ApiV2OrdersPostRequestBodyContentApplicationJsonSchemaPaymentInstrumentId:
      type: string
      enum:
        - pm_open_banking
      description: Use `pm_open_banking` for Open Banking.
      title: >-
        ApiV2OrdersPostRequestBodyContentApplicationJsonSchemaPaymentInstrumentId
    openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItemsFieldsItems:
      type: object
      properties:
        name:
          type: string
        value:
          type: string
      required:
        - name
        - value
      title: >-
        ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItemsFieldsItems
    openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItems:
      type: object
      properties:
        fiatCurrency:
          type: string
        paymentMethod:
          type: string
        name:
          type: string
        fields:
          type: array
          items:
            $ref: >-
              #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItemsFieldsItems
        redirectUrl:
          type: string
          description: >-
            URL for Open Banking payment authorization (only present for Open
            Banking payments)
      required:
        - fiatCurrency
        - paymentMethod
        - name
        - fields
      title: >-
        ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItems
    openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        orderId:
          type: string
        partnerUserId:
          type: string
        status:
          type: string
        isBuyOrSell:
          type: string
        fiatCurrency:
          type: string
        cryptoCurrency:
          type: string
        paymentMethod:
          type: string
        network:
          type: string
        networkId:
          type: string
        walletAddress:
          type: string
        quoteId:
          type: string
        fiatAmount:
          type: integer
        fiatAmountInUsd:
          type: number
          format: double
        amountPaid:
          type: integer
        cryptoAmount:
          type: number
          format: double
        conversionPrice:
          type: number
          format: double
        totalFeeInFiat:
          type: number
          format: double
        paymentDetails:
          type: array
          items:
            $ref: >-
              #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaDataPaymentDetailsItems
        txHash:
          type: string
        walletLink:
          type: string
      required:
        - orderId
        - partnerUserId
        - status
        - isBuyOrSell
        - fiatCurrency
        - cryptoCurrency
        - paymentMethod
        - network
        - networkId
        - walletAddress
        - quoteId
        - fiatAmount
        - fiatAmountInUsd
        - amountPaid
        - cryptoAmount
        - conversionPrice
        - totalFeeInFiat
        - paymentDetails
        - txHash
        - walletLink
      title: ApiV2OrdersPostResponsesContentApplicationJsonSchemaData
    openBanking:create-order_Response_200:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: create-order_Response_200
    openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaError:
      type: object
      properties:
        statusCode:
          type: integer
        message:
          type: string
        errorCode:
          type: integer
      required:
        - statusCode
        - message
        - errorCode
      title: ApiV2OrdersPostResponsesContentApplicationJsonSchemaError
    openBanking:Create-orderRequestBadRequestError:
      type: object
      properties:
        error:
          $ref: >-
            #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaError
      required:
        - error
      title: Create-orderRequestBadRequestError
    openBanking:Create-orderRequestUnauthorizedError:
      type: object
      properties:
        error:
          $ref: >-
            #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaError
      required:
        - error
      title: Create-orderRequestUnauthorizedError
    openBanking:Create-orderRequestNotFoundError:
      type: object
      properties:
        error:
          $ref: >-
            #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaError
      required:
        - error
      title: Create-orderRequestNotFoundError
    openBanking:Create-orderRequestInternalServerError:
      type: object
      properties:
        error:
          $ref: >-
            #/components/schemas/openBanking:ApiV2OrdersPostResponsesContentApplicationJsonSchemaError
      required:
        - error
      title: Create-orderRequestInternalServerError

```

## Examples



**Request**

```json
{
  "quoteId": "",
  "paymentInstrumentId": "pm_open_banking",
  "walletAddress": ""
}
```

**Response**

```json
{
  "data": {
    "orderId": "0e4715e8-961f-427b-8c45-7a6434579055",
    "partnerUserId": "2e0d7c4a-f0cc-46f8-b965-231d9bccb3da",
    "status": "AWAITING_PAYMENT_FROM_USER",
    "isBuyOrSell": "BUY",
    "fiatCurrency": "EUR",
    "cryptoCurrency": "ETH",
    "paymentMethod": "pm_open_banking",
    "network": "ethereum",
    "networkId": "",
    "walletAddress": "0x95ad61b0a150d79219dcf64e1e6cc01f0b64c4ce",
    "quoteId": "8b7a523b-8836-422c-b56b-28adb8f4e9a3",
    "fiatAmount": 27,
    "fiatAmountInUsd": 31.13,
    "amountPaid": 0,
    "cryptoAmount": 0.01165689,
    "conversionPrice": 0.00044782532130710376,
    "totalFeeInFiat": 0.97,
    "paymentDetails": [
      {
        "fiatCurrency": "EUR",
        "paymentMethod": "pm_open_banking",
        "name": "Open Banking",
        "fields": [],
        "redirectUrl": "https://secure.plaid.com/hl/ls8p12no84s0op995p3p6r38392o701563"
      }
    ],
    "txHash": "",
    "walletLink": "https://sepolia.etherscan.io/address/0x95ad61b0a150d79219dcf64e1e6cc01f0b64c4ce",
    "transactionLink": ""
  }
}
```

**SDK Code**

```python Create Order - Open Banking
import requests

url = "https://api-gateway-stg.transak.com/api/v2/orders"

payload = {
    "quoteId": "",
    "paymentInstrumentId": "pm_open_banking",
    "walletAddress": ""
}
headers = {
    "x-user-ip": "",
    "x-api-key": "",
    "authorization": "",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create Order - Open Banking
const url = 'https://api-gateway-stg.transak.com/api/v2/orders';
const options = {
  method: 'POST',
  headers: {
    'x-user-ip': '',
    'x-api-key': '',
    authorization: '',
    'Content-Type': 'application/json'
  },
  body: '{"quoteId":"","paymentInstrumentId":"pm_open_banking","walletAddress":""}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create Order - Open Banking
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-gateway-stg.transak.com/api/v2/orders"

	payload := strings.NewReader("{\n  \"quoteId\": \"\",\n  \"paymentInstrumentId\": \"pm_open_banking\",\n  \"walletAddress\": \"\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-user-ip", "")
	req.Header.Add("x-api-key", "")
	req.Header.Add("authorization", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create Order - Open Banking
require 'uri'
require 'net/http'

url = URI("https://api-gateway-stg.transak.com/api/v2/orders")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-user-ip"] = ''
request["x-api-key"] = ''
request["authorization"] = ''
request["Content-Type"] = 'application/json'
request.body = "{\n  \"quoteId\": \"\",\n  \"paymentInstrumentId\": \"pm_open_banking\",\n  \"walletAddress\": \"\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create Order - Open Banking
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api-gateway-stg.transak.com/api/v2/orders")
  .header("x-user-ip", "")
  .header("x-api-key", "")
  .header("authorization", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"quoteId\": \"\",\n  \"paymentInstrumentId\": \"pm_open_banking\",\n  \"walletAddress\": \"\"\n}")
  .asString();
```

```php Create Order - Open Banking
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api-gateway-stg.transak.com/api/v2/orders', [
  'body' => '{
  "quoteId": "",
  "paymentInstrumentId": "pm_open_banking",
  "walletAddress": ""
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'authorization' => '',
    'x-api-key' => '',
    'x-user-ip' => '',
  ],
]);

echo $response->getBody();
```

```csharp Create Order - Open Banking
using RestSharp;

var client = new RestClient("https://api-gateway-stg.transak.com/api/v2/orders");
var request = new RestRequest(Method.POST);
request.AddHeader("x-user-ip", "");
request.AddHeader("x-api-key", "");
request.AddHeader("authorization", "");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"quoteId\": \"\",\n  \"paymentInstrumentId\": \"pm_open_banking\",\n  \"walletAddress\": \"\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create Order - Open Banking
import Foundation

let headers = [
  "x-user-ip": "",
  "x-api-key": "",
  "authorization": "",
  "Content-Type": "application/json"
]
let parameters = [
  "quoteId": "",
  "paymentInstrumentId": "pm_open_banking",
  "walletAddress": ""
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-gateway-stg.transak.com/api/v2/orders")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```